package com.xkrs.common.schedule;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;

import java.time.LocalDateTime;


/**
 * 定时任务
 * @author tajochen
 */
@Configuration
@EnableScheduling
public class SaticScheduleTask {

    Logger logger = LoggerFactory.getLogger(SaticScheduleTask.class);


    /**
     * 查询新的火点信息
     */
    @Scheduled(cron = "0 0/5 * * * ?")
    private void configureTasks() {
        logger.info("执行静态定时任务时间: " + LocalDateTime.now());
        System.out.println("------" + "开始执行定时任务");
//        tempQueryPoint.findPointToLocal();
    }

}
