package com.xkrs.controller;

import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.xkrs.common.tools.GetTokenTool;
import com.xkrs.common.tools.JackSonTool;
import com.xkrs.util.Md5Util;
import com.xkrs.util.RequestUtil;
import com.xkrs.util.WeatherUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.Map;

/**
 * @Author: XinYi Song
 * @Date: 2022/2/8 14:32
 */
@RestController
public class TestController {

    @GetMapping("/getTT")
    public Map getTT(){
        String url1 = "https://111.26.161.203:443/admin/API/accounts/authorize";
        String json1 = "{\n" +
                "    \"userName\": system,\n" +
                "    \"ipAddress\": \"\",\n" +
                "    \"clientType\": \"WINPC\"\n" +
                "}";
        // 第一次鉴权
        String doPostJson = RequestUtil.doPostJson(url1, json1);
        Map map = JackSonTool.json2map(doPostJson);
        String randomKey = (String) map.get("randomKey");

        String admin123 = Md5Util.stringToMd5("admin123");
        String stringToMd5 = Md5Util.stringToMd5("system" + admin123);
        String toMd5 = Md5Util.stringToMd5(stringToMd5);
        String md5 = Md5Util.stringToMd5("system:" + "DSS:" + toMd5);
        String signature = Md5Util.stringToMd5(md5 + ":" + randomKey);

        String url2 = "https://111.26.161.203:443/admin/API/accounts/authorize";

        JSONObject jsonObject = new JSONObject();
        jsonObject.put("userName","system");
        jsonObject.put("randomKey",randomKey);
        jsonObject.put("mac","");
        jsonObject.put("encryptType","MD5");
        jsonObject.put("ipAddress","");
        jsonObject.put("signature",signature);
        jsonObject.put("clientType","WINPC");
        // 第二次鉴权
        String postJson = RequestUtil.doPostJson(url2, jsonObject.toString());
        Map map1 = JackSonTool.json2map(postJson);
        String token = (String) map1.get("token");
        return map1;
    }

    @PostMapping("/getVideo")
    public String getVideo(@RequestParam("alarmCode") String alarmCode) throws JsonProcessingException {
        String token = GetTokenTool.getToken();
        String url = "https://111.26.161.203:443/admin/API/SS/Record/GetAlarmRecords?token=" + token;
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("clientType","WINPC_V1");
        jsonObject.put("clientMac","30:9c:23:79:40:08");
        jsonObject.put("clientPushId","");
        jsonObject.put("project","PSDK");
        jsonObject.put("method","SS.Record.GetAlarmRecords");
        JSONObject jsonObject1 = new JSONObject();
        jsonObject1.put("alarmCode",alarmCode);
        jsonObject1.put("optional","/admin/API/SS/Record/GetAlarmRecords");
        jsonObject.put("data",jsonObject1);
        String s = RequestUtil.doPostJson(url, jsonObject.toString());
        ObjectMapper objectMapper = new ObjectMapper();
        JsonNode jsonNode = objectMapper.readTree(s);
        JsonNode data = jsonNode.get("data");
        JsonNode records = data.get("records").get(0);

        String urlVideo = "/admin/API/SS/Playback/StartPlaybackByFile?token=" + token;
        JSONObject jsonObject2 = new JSONObject();
        jsonObject2.put("ssId",records.get("ssId").asText());
        jsonObject2.put("optional",urlVideo);
        jsonObject2.put("fileName",records.get("recordName").asText());
        jsonObject2.put("startTime",records.get("startTime").asText());
        jsonObject2.put("endTime",records.get("endTime").asText());
        jsonObject2.put("recordType",records.get("recordType").asText());
        jsonObject2.put("diskId",records.get("diskId").asText());
        jsonObject2.put("recordSource",records.get("recordSource").asText());
        jsonObject2.put("channelId",records.get("channelId").asText());
        jsonObject2.put("streamId",records.get("streamId").asText());
        jsonObject2.put("enableRtsps","0");
        jsonObject2.put("nvrId","");
        JSONObject jsonObject3 = new JSONObject();
        jsonObject3.put("data",jsonObject2);
        String s1 = RequestUtil.doPostJson("https://111.26.161.203:443"+urlVideo, jsonObject3.toString());
        ObjectMapper objectMapper1 = new ObjectMapper();
        JsonNode jsonNode1 = objectMapper1.readTree(s1);
        JsonNode data1 = jsonNode1.get("data");
        String url1 = data1.get("url").asText();
        return url1;
    }

    /**
     * 获取天气信息的接口
     * @return
     */
    @GetMapping("/getWeather")
    public JsonNode getWeather(){
        JsonNode forecastWeather = WeatherUtils.getForecastWeather();
        JsonNode results = forecastWeather.path("results");
        JsonNode jsonNode = results.get(0);
        JsonNode daily = jsonNode.path("daily");
        JsonNode jsonNode1 = daily.get(0);

        return jsonNode1;
    }
}
